
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>


int **pipes;
int nb_procs;

int get_random() {
	srand( getpid() % 17 );
	return rand() % 1024;
}

void node(int me) {

	int nb = get_random();
	int onb;

	printf("me = %d nb=%d\n", me, nb);

	if( me == 0 ) {

		close( pipes[0][0] );
		write( pipes[0][1], &nb, sizeof(int));

		close( pipes[nb_procs-1][1]);
		read(  pipes[nb_procs-1][0], &onb, sizeof(int));

		printf("winner is %d\n", onb);

	} else {

		close(pipes[me-1][1]);
		read( pipes[me-1][0], &onb, sizeof(int));

		printf("read %d from %d\n", onb, me-1);

		if( onb > nb ) {
			nb = onb;
		}
		close(pipes[me%nb_procs][0]);
		write(pipes[me%nb_procs][1], &nb, sizeof(int));

	}


	exit(0);
}

int main(int argc, char *argv[]) {
	int pid;
	int i;

	if (argc != 2) {
		fprintf(stderr, "Usage: e4 nb\n");
		exit(-1);
	}

	nb_procs = atoi(argv[1]);

	pipes = (int**) malloc( nb_procs * sizeof(int*) );
	for(i=0; i<nb_procs; i++) {
		pipes[i] = malloc(2 * sizeof(int));
		pipe(pipes[i]);
	}

	for(i = 1; i<nb_procs; i++) {
		pid = fork();

		if( pid == 0 ) {
			node(i);
		}
	}

	node(0);

	return 0;
}
